Index: /stable/HeuristicLab.Common/3.3/EnumerableExtensions.cs
===================================================================
--- /stable/HeuristicLab.Common/3.3/EnumerableExtensions.cs	(revision 15143)
+++ /stable/HeuristicLab.Common/3.3/EnumerableExtensions.cs	(revision 15144)
@@ -88,12 +88,4 @@
     }
 
-    public static IEnumerable<T> TakeEvery<T>(this IEnumerable<T> xs, int nth) {
-      int i = 0;
-      foreach (var x in xs) {
-        if (i % nth == 0) yield return x;
-        i++;
-      }
-    }
-
     /// <summary>
     /// Compute the n-ary cartesian product of arbitrarily many sequences: http://blogs.msdn.com/b/ericlippert/archive/2010/06/28/computing-a-cartesian-product-with-linq.aspx
Index: able/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Converters/Convert.cs
===================================================================
--- /stable/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Converters/Convert.cs	(revision 15143)
+++ 	(revision )
@@ -1,55 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.Linq;
-using AutoDiff;
-using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
-
-namespace HeuristicLab.Problems.DataAnalysis.Symbolic {
-
-  ///  static class which provides methods for all converters for trees for convenience 
-  public static class Convert {
-    public static void ConvertToAutoDiff(ISymbolicExpressionTree tree, bool makeVariableWeightsVariable,
-      out List<TreeToAutoDiffTermConverter.DataForVariable> parameters, out double[] initialConstants,
-      out TreeToAutoDiffTermConverter.ParametricFunction func,
-      out TreeToAutoDiffTermConverter.ParametricFunctionGradient func_grad) {
-      var success = TreeToAutoDiffTermConverter.TryConvertToAutoDiff(tree, makeVariableWeightsVariable, out parameters, 
-        out initialConstants, out func, out func_grad);
-      if (!success) throw new ArgumentException("Cannot convert tree to AutoDiff term.");
-    }
-
-    public static ISymbolicExpressionTree Simplify(ISymbolicExpressionTree tree) {
-      var simplifier = new TreeSimplifier();
-      return simplifier.Simplify(tree);
-    }
-
-    public static ISymbolicExpressionTree CreateLinearModel(string[] variableNames, double[] coefficients,
-      double @const = 0) {
-      return LinearModelToTreeConverter.CreateTree(variableNames, coefficients, @const);
-    }
-    public static ISymbolicExpressionTree CreateLinearModel(string[] variableNames, int[] lags, double[] coefficients,
-      double @const = 0) {
-      return LinearModelToTreeConverter.CreateTree(variableNames, coefficients, @const);
-    }
-  }
-}
Index: /stable/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4.csproj
===================================================================
--- /stable/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4.csproj	(revision 15143)
+++ /stable/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4.csproj	(revision 15144)
@@ -137,5 +137,4 @@
       <SubType>Code</SubType>
     </Compile>
-    <Compile Include="Converters\Convert.cs" />
     <Compile Include="Converters\LinearModelToTreeConverter.cs" />
     <Compile Include="Converters\TreeSimplifier.cs" />